/*
 *	Utility Functions
 *
 *	(c) 2005--2006 Martin Mares <mj@ucw.cz>
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "util.h"

int verbose;

void NONRET
die(char *c, ...)
{
  va_list args;
  va_start(args, c);
  fprintf(stderr, "mdup: ");
  vfprintf(stderr, c, args);
  fputc('\n', stderr);
  va_end(args);
  exit(1);
}

void
verb(int level, char *c, ...)
{
  va_list args;
  va_start(args, c);
  if (verbose >= level)
    {
      vfprintf(stderr, c, args);
      fputc('\n', stderr);
    }
  va_end(args);
}

void *
xmalloc(uns size)
{
  void *buf = malloc(size);
  if (!buf)
    die("Unable to allocate %d bytes of memory", size);
  return buf;
}

void *
xrealloc(void *old, uns size)
{
  void *buf = realloc(old, size);
  if (!buf)
    die("Unable to allocate %d bytes of memory", size);
  return buf;
}
