/*
 *	Various Utility Functions (extracted from the UCW Library)
 *
 *	(c) 2005 Martin Mares <mj@ucw.cz>
 */

#include <stdint.h>

#ifdef __GNUC__
#define NONRET __attribute__((noreturn))
#define UNUSED __attribute__((unused))
#define likely(x) __builtin_expect((x),1)
#define unlikely(x) __builtin_expect((x),0)
#else
#define NONRET
#define UNUSED
#define likely(x) (x)
#define ulikely(x) (x)
#endif

#define STR2(c) #c
#define STR(c) STR2(c)

typedef unsigned int uns;
typedef uint8_t u8;
typedef uint16_t u16;
typedef uint32_t u32;
typedef uint64_t u64;

/* util.c */

extern int verbose;

void NONRET die(char *x, ...);
void verb(int level, char *x, ...);
void *xmalloc(uns size);
void *xrealloc(void *old, uns size);

/* sha1.c */

struct sha1_ctx {
        u64 count;
        u32 state[5];
        u8 buffer[64];
};

void sha1_init(struct sha1_ctx *ctx);
void sha1_update(struct sha1_ctx *sctx, const u8 *data, unsigned int len);
void sha1_final(struct sha1_ctx *sctx, u8 *out);
